# Typescript configuration

[![npm version](https://badge.fury.io/js/@pxlwidgets%2Ftsconfig.svg)](https://badge.fury.io/js/@pxlwidgets%2Ftsconfig)

The TS compiler base configuration for our Typescript projects.


## installation

```
npm install --save-dev @pxlwidgets/tsconfig
```

## Usage

Extend this base configuration in your `tsconfig` json file:

```json
{
    "extends": "@pxlwidgets/tsconfig"
    // ...
}
```

## Development

When making changes to the configuration, always make sure to use [semantic versioning](https://semver.org) to indicate
breaking changes. This applies to both the `tsconfig` itself and any major version bumps of npm dependencies.

### Releasing a new version

1. Commit all changes to the configuration, including documentation of the made changes under the **Unreleased** section in [CHANGELOG.md][changelog]. 
2. Create a new header in CHANGELOG.md for the new version (Do not commit!)
3. use the npm script `bump` to bump the package version:
    ```
    npm run bump <new version>
    ```
   > Replace <new version> with a valid semver version number, e.g. `npm run bump 3.1.1`.
   > This script uses yarn under the hood to allow the header change in the changelog to be included in the version commit.
4. Publish the package (publicly) on npm:
    ```
    npm publish --access=public
    ```

[changelog]: https://gitlab.pxlwidgets.com/internal/packages/typescript-project-configurations/typescript-configuration/-/blob/master/CHANGELOG.md
